from pydantic import BaseModel
from pydantic.utils import Optional


class Table(BaseModel):
    id: Optional[int]
    name: Optional[str]
    owner: Optional[str]
    column_names: Optional[list]
    types: Optional[list]
    data: Optional[list]


class Column(BaseModel):
    column: Optional[str]
    type: Optional[str]
    row_number: Optional[int]
    column_data: Optional[str]
    data: Optional[str]


class Sort(BaseModel):
    property: str
    order: str
    priority: str


class Filter(BaseModel):
    property: str
    value: str
    function: str
