from dotenv import load_dotenv

from bsition.backend.elastic.utils import create_index
from bsition.backend.postgres.tables import create_filter, create_sort
from bsition.backend.postgres.users import create_user_table
from bsition.backend.postgres.relations import create_relations_tables


def configure():
    load_dotenv()
    create_user_table()
    create_filter()
    create_sort()
    create_index("test-index")
    create_relations_tables()
