from psycopg2 import sql

from bsition.backend.postgres.utils import get_connection


def create_sort():
    conn = get_connection()
    cur = conn.cursor()
    cur.execute(
        sql.SQL(
            "CREATE TABLE t_sort (table_id INTEGER, property TEXT, _order CHAR(3), priority int)"
        )
    )
    conn.commit()


def add_sort(id, property, order, priority):
    conn = get_connection()
    cur = conn.cursor()
    cur.execute(
        sql.SQL("INSERT INTO t_sort VALUES (%s, %s, %s, %s)"),
        (id, property, order, priority),
    )
    conn.commit()


def get_sort(id):
    conn = get_connection()
    cur = conn.cursor()
    cur.execute(
        sql.SQL("SELECT * FROM t_sort WHERE table_id = {id} ORDER BY priority").format(
            id=sql.Literal(id),
        )
    )
    return cur.fetchall()


def create_filter():
    conn = get_connection()
    cur = conn.cursor()
    cur.execute(
        sql.SQL(
            "CREATE TABLE t_filter (table_id INTEGER, property TEXT, value TEXT, function TEXT CHECK (function IN ('c', 'e', 'ne', 'le', 'ge', 'l', 'g')))"
        )
    )
    conn.commit()


def add_filter(id, property, value, function):
    conn = get_connection()
    cur = conn.cursor()
    cur.execute(
        sql.SQL("INSERT INTO t_filter VALUES (%s, %s, %s, %s)").format(),
        (id, property, value, function),
    )
    conn.commit()


def get_filter(id):
    conn = get_connection()
    cur = conn.cursor()
    cur.execute(
        sql.SQL("SELECT * FROM t_filter WHERE table_id = {id}").format(
            id=sql.Literal(id),
        )
    )
    return cur.fetchall()
