import inspect

from psycopg2 import sql

from bsition.backend.postgres.utils import get_connection


def create_user_table():
    conn = get_connection()
    cur = conn.cursor()
    cur.execute(
        "CREATE TABLE users (id SERIAL PRIMARY KEY, username TEXT UNIQUE, password TEXT)"
    )
    conn.commit()


def add_user(username, password):
    conn = get_connection()
    cur = conn.cursor()
    cur.execute(
        "INSERT INTO users VALUES (DEFAULT, %s, %s)",
        (username, password),
    )
    conn.commit()


def get_users():
    conn = get_connection()
    cur = conn.cursor()
    cur.execute("SELECT * FROM users")
    return list(cur.fetchall())


def get_user_by_id(id):
    conn = get_connection()
    cur = conn.cursor()
    cur.execute(
        "SELECT * FROM users WHERE id = %s",
        id,
    )
    return cur.fetchone()


def get_user_by_username(username):
    conn = get_connection()
    cur = conn.cursor()
    cur.execute(
        sql.SQL("SELECT * FROM users WHERE LOWER(username) = LOWER({username})").format(
            username=sql.Literal(username)
        )
    )
    return cur.fetchone()


def get_user_by_username_and_password(username, password):
    conn = get_connection()
    cur = conn.cursor()
    cur.execute(
        sql.SQL(
            "SELECT * FROM users WHERE username = {username} AND password = {password}"
        ).format(username=sql.Literal(username), password=sql.Literal(password))
    )
    return cur.fetchone()


def edit_user(id, username, password):
    conn = get_connection()
    cur = conn.cursor()
    columns = inspect.getfullargspec(edit_user)[0][1:]
    data = [username, password]
    i = -1
    for column in columns:
        i += 1
        if data[i] is None:
            continue

        cur.execute(
            sql.SQL("UPDATE users SET {col} = {value} WHERE id = {id}").format(
                col=sql.Identifier(column),
                value=sql.Literal(data[i]),
                id=sql.Literal(id),
            ),
        )
    conn.commit()
